
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;


/**
Classe de test pour les déplacements des cavaliers.
 */
public class TestDepC {
    @Parameterized.Parameter
    protected Cavalier cavalierB;
    @Parameterized.Parameter
    protected Cavalier cavalierN;
    @Parameterized.Parameter
    protected Echiquier ech;

    /**
     * Méthode pour initialiser les différentes pièces et l'échiquier
     */
    @Before
    public void setUP(){
        cavalierB = new Cavalier(Piece.BLANC);
        cavalierN = new Cavalier(Piece.NOIR);
        ech = new Echiquier();
    }

    /**
     * Méthode After
     */
    @After
    public void tearDown(){
    }

    /**
     * Méthode de test pour tester le placement d'un cavalier
     * @throws Exception
     */
    @Test
    public void TestPlacement() throws Exception{
        ech.placer(cavalierB, 0, 0);
        Assert.assertEquals(cavalierB,ech.getPiece(0,0));
    }

    /**
     * Méthode de test pour tester le déplacement d'un cavalier
     * @throws Exception
     */
    @Test
    public void TestDeplacement() throws Exception{
        ech.placer(cavalierB,0,0);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalierB, ech.getPiece(1,2));
    }

    /**
     * Méthode de test pour tester la prise d'un cavalier
     * @throws Exception
     */
    @Test
    public void TestPrise() throws Exception{
        ech.placer(cavalierB, 0,0);
        ech.placer(cavalierN, 1,2);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalierB,ech.getPiece(1,2));
    }
}