import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;

/**
 Classe de test pour les déplacements des pions.
 */
public class TestDepP {
    @Parameterized.Parameter
    protected Pion pionB;
    @Parameterized.Parameter
    protected Pion pionN;
    @Parameterized.Parameter
    protected Pion pionB2;
    @Parameterized.Parameter
    protected Echiquier ech;

    /**
     * Méthode pour initialiser les différentes pièces et l'échiquier
     */
    @Before
    public void setUP(){
        pionB = new Pion(Piece.BLANC);
        pionN = new Pion(Piece.NOIR);
        pionB2 = new Pion(Piece.BLANC);
        ech = new Echiquier();
    }

    /**
     * Méthode After
     */
    @After
    public void tearDown(){
    }

    /**
     * Méthode de test pour tester le placement d'un fou
     * @throws Exception
     */
    @Test
    public void TestPlacement() throws Exception{
        ech.placer(pionB, 1,0);
        Assert.assertEquals(pionB, ech.getPiece(1,0));
    }

    /**
     * Méthode de test pour tester le déplacement d'un pion, selon sa case
     * @throws Exception
     */
    @Test
    public void TestDeplacement() throws Exception{
        /*
        Pion Blanc qui commence sur la premiere ligne
         */
        ech.placer(pionB, 6,0);
        ech.deplacer(6,0,4,0);
        Assert.assertEquals(pionB,ech.getPiece(4,0));
        /*
        Pion Noir qui commence sur la premiere ligne
         */
        ech.placer(pionN,1,0);
        ech.deplacer(1,0,3,0);
        Assert.assertEquals(pionN,ech.getPiece(3,0));
        /*
        Pion qui avance depuis une autre case que la première
         */
        ech.placer(pionB2, 5,6);
        ech.deplacer(5,6,4,6);
    }

    /**
     * Méthode de test pour tester la prise d'un pion
     * @throws Exception
     */
    @Test
    public void TestPrise() throws Exception{
        ech.placer(pionB,5,5);
        ech.placer(pionN, 4,6);
        ech.deplacer(5,5,4,6);
        Assert.assertEquals(pionB, ech.getPiece(4,6));
    }
}