import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;

/**
 Classe de test pour les déplacements des tours.
 */
public class TestDepT {
    @Parameterized.Parameter
    protected Tour tourB;
    @Parameterized.Parameter
    protected Tour tourN;
    @Parameterized.Parameter
    protected Echiquier ech;

    /**
     * Méthode pour initialiser les différentes pièces et l'échiquier
     */
    @Before
    public void setUP(){
        tourB = new Tour(Piece.BLANC);
        tourN = new Tour(Piece.NOIR);
        ech = new Echiquier();
    }

    /**
     * Méthode After
     */
    @After
    public void tearDown(){
    }

    /**
     * Méthode de test pour tester le placement d'une tour
     * @throws Exception
     */
    @Test
    public void TestPlacement() throws Exception{
        ech.placer(tourB,6,6);
        Assert.assertEquals(tourB, ech.getPiece(6,6));
    }

    /**
     * Méthode de test pour tester le déplacement d'une tour
     * @throws Exception
     */
    @Test
    public void TestDeplacement() throws Exception{
        /*
        Deplacement Vertical
         */
        ech.placer(tourB,5,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(tourB,ech.getPiece(6,5));
        /*
        Deplacement Horizontal
         */
        ech.placer(tourN,3,3);
        ech.deplacer(3,3,3,4);
        Assert.assertEquals(tourN, ech.getPiece(3,4));
    }

    /**
     * Méthode de test pour tester la prise d'une tour
     * @throws Exception
     */
    @Test
    public void TestPrise() throws Exception{
        ech.placer(tourB,5,5);
        ech.placer(tourN,6,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(tourB, ech.getPiece(6,5));
    }
}